/*
 * Agenda.cmd - written by mira308sw
 *
 * script to read/write Agenda.dat file with usb device.
 *
 * v01.01 10/12/2009 :
 *    load agenda.dat without need to reboot
 * v01.02 25/03/2010 :
 *    correct for source = CD
 * v01.03 21/12/2010 :
 *    correct a big bug in Write to RTx 
 */

#define RTX_DIR       "/I/USER_DATA/Agenda"
#define USB_DIR       "/bd0"
#define DAT_FILE      "/Agenda.dat"
#define INF_FILE      DAT_FILE ".inf"
#define NO            0
#define YES           1
#define OK            0
#define ERROR        -1

int     GetFileSize               (char* file, int* size);
int     ShowNavigationQuestionScreen (char* text, int* answer);
int     UPGCopy                   ( char *src,char *dst,int cut );
void*   UPGFindSymbol             ( char *sym );
int     ExecuteFlasherOut         ( void *funptr,... );   // max 7 parameters
char*   strcpy                    ( char *dst,char *src );
char*   strcat                    ( char *dst,char *src );


int   LoadAgenda ( void )
{
  int answ;
  int *flag;
  char *pd_CAgenda;
  void *pf_LoadData     =UPGFindSymbol( "LoadData__7CAgenda" );
  void *pf_GetObjPtr    =UPGFindSymbol( "GetObjPtr__15C_OBJ_PTR_TableUsUs" );

  if( !pf_LoadData || !pf_GetObjPtr )
    ShowNavigationQuestionScreen( "UPGFindSymbol failed!",&answ );
  else
  {
    pd_CAgenda=(char*)ExecuteFlasherOut( pf_GetObjPtr,0x3AFC,0 );
    if( !pd_CAgenda )
      ShowNavigationQuestionScreen( "GetObjPtr(CAgenda) failed!",&answ );
    else
    {
      flag = (int*)(pd_CAgenda+0x60);
      *flag = 0;
      if( ExecuteFlasherOut( pf_LoadData,pd_CAgenda )!=OK )
        ShowNavigationQuestionScreen( "LoadData failed!",&answ );
      else
        return OK;
    }
  }
  return ERROR;
}

int   main ( int argc,char* argv[] )
{
  int   size;
  int   answ=NO;
  char  l_sPath[256];
  char  l_sPathInf[256];

  strcpy( l_sPath,argv[1] );
  strcat( l_sPath,DAT_FILE );
  if( GetFileSize( l_sPath,&size )==OK )
    ShowNavigationQuestionScreen( "WRITE " DAT_FILE " ?",&answ );
  else
  {
    strcpy( l_sPath,USB_DIR );
    strcat( l_sPath,DAT_FILE );
    if( GetFileSize( l_sPath,&size )==OK )
      ShowNavigationQuestionScreen( "WRITE " DAT_FILE " ?",&answ );
  }

  if( answ==YES )
  {
    strcpy( l_sPathInf,l_sPath );
    strcat( l_sPathInf,".inf" );
    if( UPGCopy( l_sPath   ,RTX_DIR DAT_FILE,0 )!=OK ||
        UPGCopy( l_sPathInf,RTX_DIR INF_FILE,0 )!=OK )
      ShowNavigationQuestionScreen( "Error coping files",&answ );
    else if( LoadAgenda()==OK )
      ShowNavigationQuestionScreen( "Copy completed.",&answ );
  }
  else
  {
    ShowNavigationQuestionScreen( "READ " DAT_FILE " ?",&answ );
    if( answ==YES )
    {
      if( UPGCopy( RTX_DIR DAT_FILE,USB_DIR DAT_FILE,0 )!=OK ||
          UPGCopy( RTX_DIR INF_FILE,USB_DIR INF_FILE,0 )!=OK )
        ShowNavigationQuestionScreen( "Error coping files",&answ );
      else
        ShowNavigationQuestionScreen( "Copy completed.",&answ );
    }
    else
      ShowNavigationQuestionScreen( "Finish.",&answ );
  }
  return OK;
}
