/*
 * JBX_EXTRACT.CMD  by mira308sw
 *
 * WARNING!:
 *  this script work only with modified version of Builtins.out crc=19bb6041
 *  in which the function ExecuteFlasherOut can pass to called funptr till to
 *  seven integers (or addresses) parameters
 *
 * In this first version only sw:7.11 catalogue.dat version is supported.
 *
 * the goal of this script is to have a way to extract mp3 files from jukebox.
 * user will prompted to choice if to copy all albums, or confirm each album, and
 * if to copy all songs inside album, or confirm each song.
 * songs are copied on usb device, with the same folder structure of RT4 jukebox
 *
 * v 1.00: 29/12/2008   first release
 * v 1.10: 17/01/2009   add support for sw:7.10
 *
 */

/* Functions and data types from Integrated C Interpreter
 */
typedef unsigned char           BYTE;
typedef unsigned short          WORD;
typedef unsigned long           DWORD;

typedef int                     BOOL;

typedef void                    DIR;
typedef void                    FILE;

typedef enum { ERROR=-1,OK=0 }  STATUS;

#define LOAD_NO_SYMBOLS         2
#define LOAD_LOCAL_SYMBOLS      4
#define LOAD_GLOBAL_SYMBOLS     8
#define LOAD_ALL_SYMBOLS        (LOAD_LOCAL_SYMBOLS|LOAD_GLOBAL_SYMBOLS)

#define NULL                    (void*)0

#define TRUE                    1
#define FALSE                   0

int     atoi                    ( char *s );
STATUS  close                   ( int hf );
STATUS  closedir                ( DIR *d );
STATUS  EiC_ExeFile             ( int argc,char **argv );
STATUS  fclose                  ( FILE *f );
STATUS  feof                    ( FILE *f );
char*   fgets                   ( char *s,int max,FILE *f );
FILE*   fopen                   ( char *fn,char *mode );
STATUS  fputs                   ( char *s,FILE *f );
void    free                    ( void *mem );
void    loadModule              ( int hf,int mode );
STATUS  logMsg                  ( char *fmt,...);
void*   malloc                  ( int size );
STATUS  mv                      ( char *src,char *dest );
int     open                    ( char *fn,int access,int mode );
DIR*    opendir                 ( char *dn );
int     putchar                 ( int c );
char*   strcat                  ( char *dest,char *s );
int     strcmp                  ( char *s1,char *s2 );
char*   strcpy                  ( char *dest,char *src );
int     strlen                  ( char *s );
int     strncmp                 ( char *s1,char *s2,int max );
char*   strrchr                 ( char *s,int c );
char*   strstr                  ( char *s1,char *s2 );
void    taskDelay               ( int tick );
DWORD   tickGet                 ( void );
STATUS  xcopy                   ( char *src,char *dest );
STATUS  xdelete                 ( char *src );

/* functions not yet known (for me)
 *
void    copy                    ( void );
void    creat                   ( void );
void    ExeScriptFile           ( void );
void    moduleFindByNameAndPath ( void );
void    rm                      ( void );
void    sqrt                    ( void );
void    symFindByNameAndType    ( void );
void    unldByModuleId          ( void );
void    unldByNameAndPath       ( void );
 */

/* Funcions and data type from modified builtins.out crc=19bb6041
 */
void    AddGatewayHistory         ( void );
STATUS  AddUPGHistoryHeader       ( char *cd,char *target,char *action );
STATUS  BootRomFormatTffs         ( void );
void    CheckCRCDrive             ( void );
STATUS  CheckCRCFile              ( char *fn );
STATUS  ComputeCRCFile            ( char *fn,char *crc);
STATUS  EnableHistoryHandler      ( int on );
STATUS  EnableSetPowerOffHandler  ( int on );
int     Execute                   ( void *funptr );
int     ExecuteFlasherOut         ( void *funptr,... );   // max 7 parameters
void    Format                    ( void );
STATUS  GetBootromVersion         ( char *ver );
STATUS  GetCDVersion              ( char *ver );
STATUS  GetCurrentDateClock       ( char *dc );
STATUS  GetModuleId               ( int mid,char *tid );
STATUS  GetSearchResult           ( int ndx,char *res,char *path );
STATUS  GetSourceDrive            ( char *path );
STATUS  InstallHDDTestFiles       ( void );
int     IsFpInLoader              ( void );
int     IsPartitionCaseSensitive  ( void );
int     IsPartitionUnderRepair    ( void );
void    loadFile                  ( void );
STATUS  LockCDEject               ( int on );
STATUS  ReadFileCRC               ( char *fn,char *crc );
void    RebootSystem              ( void );
int     SearchAndTargetFileExclu  ( char *fn,char *tn,char *par[],int npar,char *root,char *dir );
STATUS  SetBootLoaderFlag         ( int stayInBootLoader );
STATUS  SetMasterFlashingOn       ( void );
STATUS  SetPartitionRepairState   ( int repair );
STATUS  SetPower                  ( int on );
STATUS  SetRedLedOn               ( int on );
STATUS  SetUPGInProgressInCDD     ( int on );
STATUS  SetUpgradeLogging         ( int on );
STATUS  StopCOMModule             ( int mid );
STATUS  StopHDDActivity           ( void );
STATUS  UpdateFSImage             ( void );
STATUS  UPGCopy                   ( char *src,char *dst,int cut );
STATUS  UPGDelete                 ( char *fn );
void*   UPGFindSymbol             ( char *sym );
STATUS  UPGLogMsg                 ( char *fmt,... );

/* Functions and data types from MMI module
 */
#define NO                            0
#define YES                           1

STATUS  ClearScreen                   ( void );
STATUS  ShowNavigationBargraph        ( void );
STATUS  StepBargraph                  ( char *txt, int per );
STATUS  ShowNavigationQuestionScreen  ( char *txt, int *answ );

/* Functions and data types for RTx system
 */
// Drive letters
#define DRIVE_USB       "/bd0"
#define DRIVE_HDD       "/C"
#define DRIVE_CD        "/D"
#define DRIVE_TFFS      "/F"
#define DRIVE_NAV       "/H"
#define DRIVE_USER      "/I"
#define DRIVE_JBX       "/J"


/* extra C standard function, pull out through modified Builtins.out
 */

void *pf_fread;
void *pf_fwrite;
void *pf_fseek;
void *pf_ftell;
void *pf_sprintf;
void *pf_memset;
void *pf_strchr;

STATUS InitFunctionPtr ( void )
{
  int   l_iAnsw;

  pf_fread    =UPGFindSymbol( "fread" );
  pf_fwrite   =UPGFindSymbol( "fwrite" );
  pf_fseek    =UPGFindSymbol( "fseek" );
  pf_ftell    =UPGFindSymbol( "ftell" );
  pf_sprintf  =UPGFindSymbol( "sprintf" );
  pf_memset   =UPGFindSymbol( "memset" );
  pf_strchr   =UPGFindSymbol( "strchr" );

  if( pf_fread  !=NULL &&
      pf_fwrite !=NULL &&
      pf_fseek  !=NULL &&
      pf_ftell  !=NULL &&
      pf_sprintf!=NULL &&
      pf_memset !=NULL &&
      pf_strchr !=NULL )    return OK;

  ShowNavigationQuestionScreen( "InitFunctionPtr() FAILED!", &l_iAnsw );
  return ERROR;
}

/* these functions work only on modified Builtins.out crc=19bb6041
 */
#define FREAD( ptr,size,n,fp )      ExecuteFlasherOut( pf_fread,ptr,size,n,fp )
#define FWRITE( ptr,size,n,fp )     ExecuteFlasherOut( pf_fwrite,ptr,size,n,fp )
#define FSEEK( fp,offset,from )     ExecuteFlasherOut( pf_fseek,fp,offset,from )
#define FTELL( fp )                 ExecuteFlasherOut( pf_ftell,fp )
#define MEMSET( ptr,value,len )     ExecuteFlasherOut( pf_memset,ptr,value,len )
#define STRCHR( str,chr )    (char*)ExecuteFlasherOut( pf_strchr,str,chr )
#define EFO                         ExecuteFlasherOut

/* Other builtins Functions and data type
 */
int     UPGSearchFile       ( char *fn, char *root, char *param, char *tabledir );
STATUS  UPGGetSearchResult  ( int ndx,char *res );
STATUS  GetFileSize         ( char *fn, int *size);


/****************************** JBX_EXTRACT.CMD ******************************/

typedef struct
{
  int   m_unit;
  int   m_mega;
} t_longint;

#define _1MBYTE                 (1048576)
#define BREAK                   (2)
#define MAX_SIZE                (50*_1MBYTE)
#define USB_NOTCOPIED_FILE      "/JBXTR_NOTCOPIED.TXT"
#define USB_LASTCOPIED_FILE     "/JBXTR_LASTCOPIED.TXT"
#define USB_LIST_FILE           "/JBXTR_FILELIST.TXT"
#define COL_SEP                 '\t'

#define JBX_CATALOGUE           DRIVE_JBX "/rt3ev_templists/Catalogue.dat"

#define MAX_CATITM              3255
#define MAX_CATSNG              3005


typedef struct cathdr   //catalogue header
{
  DWORD tsng;           //total songs number
  DWORD talb;           //total albums number
} t_cathdr;

typedef struct catitm_710   //catalogue item description
{
  DWORD type;           //1=album   0=song
  char  name[256];
  DWORD lpath;          //length of path before name
  BYTE  undef[28];
  WORD  nsng;           //song number inside catalogue
  WORD  asng;           //song number inside album
  WORD  nalb;           //album number
  WORD  dummy;
} t_catitm_710;

typedef struct catitm_711   //catalogue item description
{
  DWORD type;           //1=album   0=song
  char  name[256];
  DWORD lpath;          //length of path before name
  BYTE  undef[92];
  WORD  nsng;           //song number inside catalogue
  WORD  asng;           //song number inside album
  WORD  nalb;           //album number
  WORD  dummy;
} t_catitm_711;

typedef struct catalogue_710
{
  t_cathdr      hdr;
  t_catitm_710  itm[MAX_CATITM];
  DWORD         isng[MAX_CATSNG]; //index of songs in itm[] array
} t_catalogue_710;

typedef struct catalogue_711
{
  t_cathdr      hdr;
  t_catitm_711  itm[MAX_CATITM];
  DWORD         isng[MAX_CATSNG]; //index of songs in itm[] array
} t_catalogue_711;

typedef struct sngdef
{
  DWORD type;           //1=album   0=song
  char  name[256];
  DWORD lpath;          //length of path before name
} t_sngdef;

#define CAT_710       sizeof( t_catalogue_710 )
#define CAT_711       sizeof( t_catalogue_711 )


int  ItmRead ( int p_iType,FILE *p_pCat,t_sngdef *p_sng )
{
  t_catitm_710 itm_710;
  t_catitm_711 itm_711;

  switch( p_iType )
  {
  case CAT_710:
    FREAD( &itm_710,sizeof( itm_710 ),1,p_pCat );
    p_sng->type=itm_710.type;
    strcpy( p_sng->name,itm_710.name );
    p_sng->lpath=itm_710.lpath;
    return OK;
  case CAT_711:
    FREAD( &itm_711,sizeof( itm_711 ),1,p_pCat );
    p_sng->type=itm_711.type;
    strcpy( p_sng->name,itm_711.name );
    p_sng->lpath=itm_711.lpath;
    return OK;
  }
  return ERROR;
}

void AddFileSize ( t_longint *p_liSize,int p_iAdd )
{
  p_liSize->m_unit += p_iAdd;
  if( p_liSize->m_unit > _1MBYTE )
  {
    p_liSize->m_mega += p_liSize->m_unit/_1MBYTE;
    p_liSize->m_unit %= _1MBYTE;
  }
}

int  IsMP3 ( char *p_sFile )
{
  int   l_l=strlen( p_sFile );
  char *l_p=p_sFile+l_l-4;
  if( l_p<=p_sFile || l_l>256-4 )
    return FALSE;
  return  l_p[0]=='.' &&
        ( l_p[1]=='m' || l_p[1]=='M' ) &&
        ( l_p[2]=='p' || l_p[2]=='P' ) &&
          l_p[3]=='3';
}

int  CreateList ( FILE *p_pList,t_longint *p_liSize )
{
  char  l_sText[256];
  int   l_nFile;
  int   l_iSize;
  int   l_i;
  int   l_iTot;
  int   l_iCopyAlb=YES;
  int   l_iAllAlb=YES;
  int   l_iAllSongs=YES;
  int   l_iCopy=YES;
  int   l_iType;
  FILE* l_pCat;
  t_cathdr  l_hdr;
  t_sngdef  l_itm;

  if( GetFileSize( JBX_CATALOGUE,&l_iType )!=OK )
    return ERROR;

  l_pCat=fopen( JBX_CATALOGUE,"rb" );
  if( l_pCat==NULL )
    return ERROR;

  ShowNavigationQuestionScreen( "Copy all Albums ?",&l_iAllAlb );

  p_liSize->m_unit=0;
  p_liSize->m_mega=0;

  FREAD( &l_hdr,sizeof( l_hdr ),1,l_pCat );

  l_nFile=0;
  l_iTot=l_hdr.tsng+l_hdr.talb;

  for( l_i=0 ; l_i<l_iTot ; l_i++ )
  {
    ItmRead( l_iType,l_pCat,&l_itm );
//    FREAD( &l_itm,sizeof( l_itm ),1,l_pCat );
    if( l_itm.type==1 )                   // album name
    {
      if( l_iAllAlb==NO )
      {
        EFO( pf_sprintf,l_sText,"Album %s ?",l_itm.name+l_itm.lpath-1 );
        ShowNavigationQuestionScreen( l_sText,&l_iCopyAlb );
        if( l_iCopyAlb==YES )
        {
          EFO( pf_sprintf,l_sText,"All songs of %s ?",l_itm.name+l_itm.lpath-1 );
          ShowNavigationQuestionScreen( l_sText,&l_iAllSongs );
          l_iCopy=YES;
        }
      }
    }
    else if( l_iCopyAlb==YES )
    {
      if( l_iAllSongs==NO )
      {
        EFO( pf_sprintf,l_sText,"Song %s ?",l_itm.name+l_itm.lpath-1 );
        ShowNavigationQuestionScreen( l_sText,&l_iCopy );
      }
      if( l_iCopy==YES )
      {
        ShowNavigationBargraph();
        StepBargraph( l_itm.name+l_itm.lpath-1,100*l_i/l_iTot );

        fputs( STRCHR( l_itm.name+1,'/' ),p_pList );
        if( GetFileSize( l_itm.name,&l_iSize )!=ERROR )
        {
          EFO( pf_sprintf,l_sText,"%c%d",COL_SEP,l_iSize );
          fputs( l_sText,p_pList );
          AddFileSize( p_liSize,l_iSize );
        }
        fputs( "\r\n",p_pList );
        l_nFile++;
      }
    }
  }
  fclose( l_pCat );

  if( l_nFile<=0 )
  {
    ShowNavigationBargraph();
    StepBargraph( "Nothing to copy!",100 );
    taskDelay( 3000 );
  }
  return l_nFile;
}

int  ReadLastCopied ( char *p_sPath )
{
  char  l_s[16];
  char *l_sLast;
  FILE *l_pLast;
  char  l_sPath[256];

  strcpy( l_sPath,p_sPath );
  strcat( l_sPath,USB_LASTCOPIED_FILE );
  l_pLast=fopen( l_sPath,"r" );
  if( l_pLast==NULL )
    return 0;
  l_sLast=fgets( l_s,sizeof( l_s ),l_pLast );
  fclose( l_pLast );
  if( l_sLast==NULL )
    return 0;
  return atoi( l_sLast );
}

int  WriteLastCopied ( char *p_sPath,int p_iLast )
{
  char  l_s[16];
  FILE *l_pLast;
  char  l_sPath[256];

  strcpy( l_sPath,p_sPath );
  strcat( l_sPath,USB_LASTCOPIED_FILE );
  l_pLast=fopen( l_sPath,"w" );
  if( l_pLast==NULL )
    return ERROR;
  EFO( pf_sprintf,l_s,"%d",p_iLast );
  fputs( l_s,l_pLast );
  fputs( "\n",l_pLast );
  fclose( l_pLast );
  return OK;
}

int  WriteNotCopied ( char *p_sPath,char *p_sFile )
{
  FILE *l_pNoCpy;
  char  l_sPath[256];

  strcpy( l_sPath,p_sPath );
  strcat( l_sPath,USB_NOTCOPIED_FILE );

  if( p_sFile )
    l_pNoCpy=fopen( l_sPath,"a" );
  else
    l_pNoCpy=fopen( l_sPath,"w" );

  if( l_pNoCpy==NULL )
    return ERROR;

  if( p_sFile )
  {
    fputs( p_sFile,l_pNoCpy );
    fputs( "\r\n",l_pNoCpy );
  }
  fclose( l_pNoCpy );
  return OK;
}

int  CopyFile ( FILE* p_pList,int p_i,int p_pLast,char *p_sJob )
{
  char l_sSrc[256];
  char l_sDst[256];
  char l_sFile[272];
  char *l_p;
  int  l_iSize;

  for( ; p_pLast<p_i ; p_pLast++ )
    if( fgets( l_sFile,sizeof( l_sFile ),p_pList )==NULL )
      return ERROR;
  for( l_p=l_sFile ; *l_p && *l_p!=COL_SEP && *l_p!='\n' && *l_p!='\r' ; l_p++ );
  *l_p=0;
  strcpy( l_sSrc,DRIVE_JBX );
  strcat( l_sSrc,l_sFile );
  strcpy( l_sDst,DRIVE_USB );
  strcat( l_sDst,l_sFile );
  if( GetFileSize( l_sSrc,&l_iSize )==ERROR )
  {
    WriteNotCopied( p_sJob,l_sFile );
    return OK;
  }
  if( UPGCopy( l_sSrc,l_sDst,FALSE )==ERROR )
  {
    WriteNotCopied( p_sJob,l_sFile );
    return ERROR;
  }
  return l_iSize;
}

int  CopyList ( FILE* p_pList,int p_iTotal,char *p_sJob )
{
  char  l_sDescr[256];
  char  l_s[256];
  int   l_i;
  int   l_iSize;
  int   l_iPerc;
  int   l_iList=0;
  int   l_iLast=ReadLastCopied( p_sJob );

  strcpy( l_sDescr,"Copy files" );
  do
  {
    l_iPerc=0;
    l_iSize=0;
    ShowNavigationBargraph();
    do
    {
      if( l_iSize>=l_iPerc )
      {
        StepBargraph( l_sDescr,l_iSize/(MAX_SIZE/100) );
        l_iPerc=l_iSize+(MAX_SIZE/10);
      }
      l_i=CopyFile( p_pList,++l_iLast,l_iList,p_sJob );
      if( l_i==ERROR )
        return ERROR;
      l_iSize+=l_i;
      l_iList=l_iLast;
    }
    while( l_iSize<MAX_SIZE && l_iLast<p_iTotal );

    if( l_iLast>=p_iTotal )
      l_i=-1;
    else
    {
      EFO( pf_sprintf,l_s,"%d%% done. Continue ?",100*l_iLast/p_iTotal );
      ShowNavigationQuestionScreen( l_s,&l_i );
    }
  }
  while( l_i==YES );

  WriteLastCopied( p_sJob,l_iLast );
  return ( l_i<0 ? OK : BREAK );
}

int ExecuteJob ( char *p_sJob )
{
  char  l_sList[256];
  char  l_s[256];
  int   l_iAnsw;
  int   l_iLast;
  int   l_iCreate;
  int   l_nFile;
  FILE* l_pList;
  t_longint l_liTotSize;
  char *l_p;

  strcpy( l_sList,p_sJob );
  strcat( l_sList,USB_LIST_FILE );
  l_pList=fopen( l_sList,"r" );
  if( l_pList==NULL )
    l_iCreate=TRUE;
  else
  {
    l_liTotSize.m_unit=0;
    l_liTotSize.m_mega=0;
    l_iLast=ReadLastCopied( p_sJob );

    for( l_nFile=0 ; fgets( l_s,sizeof( l_s ),l_pList )!=NULL ; l_nFile++ )
    {
      if( l_nFile>=l_iLast )
        AddFileSize( &l_liTotSize,atoi( STRCHR( l_s,COL_SEP )+1 ) );
    }
    fclose( l_pList );

    if( !l_nFile )
      l_iCreate=TRUE;
    else
    {
      l_iCreate=FALSE;
      EFO( pf_sprintf,l_s,"%d%% already copied. Continue ?",100*l_iLast/l_nFile );
      ShowNavigationQuestionScreen( l_s,&l_iAnsw );
      if( l_iAnsw==NO )
      {
        ShowNavigationQuestionScreen( "Abort this copy and start a new ?",&l_iAnsw );
        if( &l_iAnsw==NO )
          return BREAK;
        l_iCreate=TRUE;
      }
    }
  }
  if( l_iCreate==TRUE )
  {
    l_iLast=0;

    if( WriteLastCopied( p_sJob,l_iLast )==ERROR ||
        WriteNotCopied( p_sJob,NULL )==ERROR )
      return ERROR;

    l_pList=fopen( l_sList,"w" );
    if( l_pList==NULL )
      return ERROR;
    l_nFile=CreateList( l_pList,&l_liTotSize );
    fclose( l_pList );
    if( l_nFile<=0 )
    {
      UPGDelete( l_sList );
      return ERROR;
    }
  }
  EFO( pf_sprintf,l_s,"%d files. ",l_nFile-l_iLast );
  l_p=l_s+strlen( l_s );
  if( l_liTotSize.m_mega>1024 )
    EFO( pf_sprintf,l_p,"%dGByte",(l_liTotSize.m_mega+1023)/1024 );
  else if( l_liTotSize.m_mega )
    EFO( pf_sprintf,l_p,"%dMByte",l_liTotSize.m_mega );
  else if( l_liTotSize.m_unit>1024 )
    EFO( pf_sprintf,l_p,"%dKByte",(l_liTotSize.m_unit+1023)/1024 );
  else
    EFO( pf_sprintf,l_p,"%dByte",l_liTotSize.m_unit );
  strcat( l_p," required. Continue ?" );
  ShowNavigationQuestionScreen( l_s,&l_iAnsw );
  if( l_iAnsw==NO )
    return BREAK;

  l_pList=fopen( l_sList,"r" );
  if( l_pList==NULL )
    return ERROR;
  l_iAnsw=CopyList( l_pList,l_nFile,p_sJob );
  fclose( l_pList );

  return l_iAnsw;
}

int  isCatalogueCorrect ( void )
{
  int   l_size;
  if( GetFileSize( JBX_CATALOGUE,&l_size )!=OK )
    return ERROR;
  switch( l_size )
  {
  case CAT_710:
  case CAT_711:
    return TRUE;
  }
  return FALSE;
}

int  jbx_extract ( void )
{
  int   l_i;
  int   l_iAnsw;

  if( isCatalogueCorrect()!=TRUE )
  {
    ShowNavigationQuestionScreen( "Incorrect Catalogue.dat!", &l_iAnsw );
    return ERROR;
  }

  l_i=ExecuteJob( DRIVE_USB );
  if( l_i!=OK )
    return l_i;

  UPGDelete( DRIVE_USB USB_LIST_FILE );
  UPGDelete( DRIVE_USB USB_LASTCOPIED_FILE );
  return l_i;
}

int  main ( int argc, char **argv )
{
  int  l_iAnsw = FALSE;

  if( InitFunctionPtr()==OK )
  {
    switch( jbx_extract() )
    {
    case ERROR:
      ShowNavigationQuestionScreen( "Copy failed", &l_iAnsw );
      break;
    case OK:
      ShowNavigationQuestionScreen( "Copy completed!",&l_iAnsw );
      break;
    case BREAK:
      ShowNavigationQuestionScreen( "Copy halted by user!",&l_iAnsw );
      break;
    }
  }
  ClearScreen();
  return OK;
}

